package com.blamejared.compat.betterwithmods.base.blockrecipes;

import java.util.stream.Collector;
import java.util.stream.Collectors;
import java.util.function.Function;
import com.blamejared.mtlib.helpers.LogHelper;
import com.google.common.collect.Lists;
import com.blamejared.mtlib.helpers.InputHelper;
import crafttweaker.api.item.IItemStack;
import betterwithmods.common.registry.block.managers.CraftingManagerBlock;
import net.minecraft.item.ItemStack;
import java.util.List;
import com.blamejared.mtlib.utils.BaseAction;
import betterwithmods.common.registry.block.recipe.BlockRecipe;

public class BlockRecipeRemove<T extends BlockRecipe> extends BaseAction
{
    private final List<ItemStack> outputs;
    private CraftingManagerBlock<T> manager;
    
    public BlockRecipeRemove(final String name, final CraftingManagerBlock<T> manager, final IItemStack[] outputs) {
        this(name, manager, Lists.newArrayList(InputHelper.toStacks(outputs)));
    }
    
    private BlockRecipeRemove(final String name, final CraftingManagerBlock<T> manager, final List<ItemStack> outputs) {
        super(name);
        this.manager = manager;
        this.outputs = outputs;
    }
    
    public void apply() {
        if (!this.manager.remove((List)this.outputs)) {
            LogHelper.logWarning(String.format("No recipes were removed for output %s", this.getRecipeInfo()));
        }
        else {
            LogHelper.logInfo(String.format("Successfully removed all recipes for %s", this.getRecipeInfo()));
        }
    }
    
    protected String getRecipeInfo() {
        return String.format("%s - %s", this.name, this.outputs.stream().map((Function<? super Object, ?>)ItemStack::func_82833_r).collect((Collector<? super Object, ?, String>)Collectors.joining(",")));
    }
}
